// C++ interface header file.
//
// Generated by SIP v2.5 on Fri Aug 10 18:47:39 2001
//
// Terms and Conditions
// 
// Copyright (c) 1998, 1999, 2000, 2001
// 	Phil Thompson <phil@river-bank.demon.co.uk>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#ifndef _qtQWorkspace_h
#define	_qtQWorkspace_h


#include "sipqtQWidget.h"
#include "sipqtQString.h"
#include "sipqtQWidgetList.h"
#include "sipqtQSizePolicy.h"
#include "sipqtQSize.h"
#include "sipqtQChildEvent.h"
#include "sipqtQResizeEvent.h"
#include "sipqtQObject.h"
#include "sipqtQEvent.h"
#include "sipqtQShowEvent.h"

#line 20 "qworkspace.sip"
#include <qworkspace.h>
#line 51 "sipqtQWorkspace.h"

extern SIP_EXPORT PyObject *sipClass_QWorkspace;
extern SIP_EXPORT PyMethodDef sipClassAttrTab_QWorkspace[];

extern SIP_EXPORT const void *sipCast_QWorkspace Py_PROTO((const void *,PyObject *));
extern SIP_EXPORT PyObject *sipNew_QWorkspace Py_PROTO((PyObject *,PyObject *));


class SIP_EXPORT sipQWorkspace : public QWorkspace
{
public:
	sipQWorkspace(QWidget *,const char *);
	~sipQWorkspace();
	void childEvent(QChildEvent *);
	void timerEvent(QTimerEvent *);
	void removeChild(QObject *);
	void insertChild(QObject *);
	void setName(const char *);
	bool eventFilter(QObject *,QEvent *);
	bool event(QEvent *);
	void setMicroFocusHint(int,int,int,int,bool);
	void setKeyCompression(bool);
	void setCRect(const QRect&);
	void setFRect(const QRect&);
	void setWFlags(unsigned);
	void setWState(unsigned);
	void destroy(bool,bool);
#if defined(SIP_VERS_WS_X11)
	void create(unsigned,bool,bool);
#endif
#if defined(SIP_VERS_WS_WIN)
	void create(struct HWND__ *,bool,bool);
#endif
	void styleChange(QStyle&);
	void updateMask();
	void customEvent(QCustomEvent *);
	void hideEvent(QHideEvent *);
	void showEvent(QShowEvent *);
	void dropEvent(QDropEvent *);
	void dragLeaveEvent(QDragLeaveEvent *);
	void dragMoveEvent(QDragMoveEvent *);
	void dragEnterEvent(QDragEnterEvent *);
	void wheelEvent(QWheelEvent *);
	bool focusNextPrevChild(bool);
	void fontChange(const QFont&);
	void paletteChange(const QPalette&);
	void backgroundPixmapChange(const QPixmap&);
	void backgroundColorChange(const QColor&);
	void enabledChange(bool);
	void closeEvent(QCloseEvent *);
	void resizeEvent(QResizeEvent *);
	void moveEvent(QMoveEvent *);
	void paintEvent(QPaintEvent *);
	void leaveEvent(QEvent *);
	void enterEvent(QEvent *);
	void focusOutEvent(QFocusEvent *);
	void focusInEvent(QFocusEvent *);
	void keyReleaseEvent(QKeyEvent *);
	void keyPressEvent(QKeyEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
	void mousePressEvent(QMouseEvent *);
	void setGeometry(const QRect&);
	void polish();
	void showNormal();
	void showMaximized();
	void showMinimized();
	void setUpdatesEnabled(bool);
	void setFocus();
	void setMouseTracking(bool);
	void setIconText(const QString&);
	void setIcon(const QPixmap&);
	void setCaption(const QString&);
	void setGeometry(int,int,int,int);
	void resize(int,int);
	void move(int,int);
	void hide();
	void show();
	void setEnabled(bool);
	bool customWhatsThis() const;
	void setAutoMask(bool);
	void setAcceptDrops(bool);
	void reparent(QWidget *,unsigned,const QPoint&,bool);
	int heightForWidth(int) const;
	QSizePolicy sizePolicy() const;
	QSize minimumSizeHint() const;
	bool close(bool);
	void setFocusProxy(QWidget *);
	void setFocusPolicy(QWidget::FocusPolicy);
	void setActiveWindow();
	void setMask(const QRegion&);
	void setMask(const QBitmap&);
	void unsetCursor();
	void setPalettePropagation(QWidget::PropagationMode);
	void setFontPropagation(QWidget::PropagationMode);
	void setBackgroundMode(QWidget::BackgroundMode);
	void setSizeIncrement(int,int);
	void setMaximumSize(int,int);
	void setMinimumSize(int,int);
	void adjustSize();
	QSize sizeHint() const;
	void setCursor(const QCursor&);
	void setFont(const QFont&);
	void setPalette(const QPalette&);
	void setBackgroundPixmap(const QPixmap&);
	void setBackgroundColor(const QColor&);
	const char * className() const;

	// There is a public member function for every protected member
	// function visible from this class.

	const QObject * sipProtect_sender();
	void sipProtect_timerEvent(QTimerEvent *);
	bool sipProtect_event(QEvent *);
	void sipProtect_mousePressEvent(QMouseEvent *);
	void sipProtect_mouseReleaseEvent(QMouseEvent *);
	void sipProtect_mouseDoubleClickEvent(QMouseEvent *);
	void sipProtect_mouseMoveEvent(QMouseEvent *);
	void sipProtect_keyPressEvent(QKeyEvent *);
	void sipProtect_keyReleaseEvent(QKeyEvent *);
	void sipProtect_focusInEvent(QFocusEvent *);
	void sipProtect_focusOutEvent(QFocusEvent *);
	void sipProtect_enterEvent(QEvent *);
	void sipProtect_leaveEvent(QEvent *);
	void sipProtect_paintEvent(QPaintEvent *);
	void sipProtect_moveEvent(QMoveEvent *);
	void sipProtect_closeEvent(QCloseEvent *);
	void sipProtect_enabledChange(bool);
	void sipProtect_backgroundColorChange(const QColor&);
	void sipProtect_backgroundPixmapChange(const QPixmap&);
	void sipProtect_paletteChange(const QPalette&);
	void sipProtect_fontChange(const QFont&);
	unsigned sipProtect_getWFlags();
	void sipProtect_clearWFlags(unsigned);
	bool sipProtect_focusNextPrevChild(bool);
	void sipProtect_wheelEvent(QWheelEvent *);
	void sipProtect_dragEnterEvent(QDragEnterEvent *);
	void sipProtect_dragMoveEvent(QDragMoveEvent *);
	void sipProtect_dragLeaveEvent(QDragLeaveEvent *);
	void sipProtect_dropEvent(QDropEvent *);
	void sipProtect_hideEvent(QHideEvent *);
	void sipProtect_customEvent(QCustomEvent *);
	void sipProtect_updateMask();
	void sipProtect_styleChange(QStyle&);
	int sipProtect_metric(int);
#if defined(SIP_VERS_WS_WIN)
	void sipProtect_create(struct HWND__ *,bool,bool);
#endif
#if defined(SIP_VERS_WS_X11)
	void sipProtect_create(unsigned,bool,bool);
#endif
	void sipProtect_destroy(bool,bool);
	unsigned sipProtect_getWState();
	void sipProtect_setWState(unsigned);
	void sipProtect_clearWState(unsigned);
	void sipProtect_setWFlags(unsigned);
	void sipProtect_setFRect(const QRect&);
	void sipProtect_setCRect(const QRect&);
	void sipProtect_setKeyCompression(bool);
	void sipProtect_setMicroFocusHint(int,int,int,int,bool);
	void sipProtect_childEvent(QChildEvent *);
	void sipProtect_resizeEvent(QResizeEvent *);
	bool sipProtect_eventFilter(QObject *,QEvent *);
	void sipProtect_showEvent(QShowEvent *);

	// There is a public member function for every Qt signal that can be
	// emitted by this object.  This function is called by Python to emit
	// the signal.

	int sipEmit_destroyed(PyObject *sipArgs);
	int sipEmit_windowActivated(PyObject *sipArgs);

	sipThisType *sipPyThis;

private:
	sipQWorkspace(const sipQWorkspace &);
	sipQWorkspace &operator = (const sipQWorkspace &);

	sipMethodCache sipPyMethods[91];
};

extern SIP_EXPORT int sipCanConvertTo_QWorkspace Py_PROTO((PyObject *));
extern SIP_EXPORT void sipConvertTo_QWorkspace Py_PROTO((PyObject *,QWorkspace **,int,int *));
extern SIP_EXPORT QWorkspace *sipForceConvertTo_QWorkspace Py_PROTO((PyObject *,int *));

#endif
